data {
    int N;
    real Y[N];
    real X[N];
    real G[N];
}
parameters {
    real a1;
    real a2;
    real b1;
    real b2;
    real<lower = 0.0> sgm;
}
transformed parameters {
    real a[N];
    real b[N];
    for (i in 1:N) {
        a[i] = a1 + a2 * G[i];
        b[i] = b1 + b2 * G[i];
    }
}
model {
    a1 ~ normal(0, 10);
    a2 ~ normal(0, 10);
    b1 ~ normal(0, 10);
    b2 ~ normal(0, 10);
    sgm ~ exponential(0.1);
    for (i in 1:N) {
        Y[i] ~ normal(a[i] + b[i] * X[i], sgm);
    }
}
